import java.awt.*;


public class Graphics02 extends java.applet.Applet implements Runnable
{
 int face1; int face2; int face;   // variables used in the rollDice() 
 times=0;  // variable used to adjust the degree of the Arc, used in rollDice()
 total=8000;  // total times of rolls, used in rollDice()
 // array to save the times of each face from 2 to 12 after a round of rolls 
 int frequency[] = new int[11]; 
 // array to save the percentage of each face              
 double percentage[]=new double[11]; 
 // array to save the degree of each Arc on the pie chart                   
 int degree[] = new int[11]; 
 Thread runner;  // a thread
 Image offscreenImg;   // image object for double buffering
 Graphics offscreenG;   // graphics object for double buffering
 
 // Override java.applet.Applet.init:
 public void init()
 {
   setBackground(Color.white);
   setForeground(Color.black);
   // create an off-screen image for double buffering:
   offscreenImg=createImage(this.size().width, this.size().height);
   // get off-screen graphics context:
   offscreenG=offscreenImg.getGraphics();
   for (int i=0; i<11; i++) {
     frequency[i] = 0;  // initialize frequency of each face to zero
     percentage[i] = 0; // initialize percentage of each face to zero 
   }
 }

 // Override java.applet.Applet.start:
 public void start()
{
  if(runner==null)
  {
   runner=new Thread(this);  
   runner.start();   // start a thread
  }
 }

 // Override java.applet.Applet.stop:
 public void stop()
 {            
  if(runner != null)
  {
   runner.stop();
   runner=null;
  }
 }


 // Calculate the random distribution of rolls of two dices, including frequency 
 // face 2 to face 12, percentage of face 2 to face 12, and according to this 
 // distribution, how many degree each distribution occupies on the pie chart
 public void rolldice() {
   times ++;  //accumulation of the times of  rolling 2 dices, less than 8000
   face1=1+(int)(Math.random()*6);
   face2=1+(int)(Math.random()*6);
   face=face1+face2; //random distribution of faces
   ++frequency[face-2];  // frequency of each face from 2 to 12
  // degree of each face occupies on the pie chart, they are adjusted by being 
  // divided by times+0.5                                           
   for (face=2; face<=12; face++) {
     degree[face-2] = (int)((double)frequency[face-   
     2]*(double)360.0/(double)times+0.5); 
//     percentage[face-2]=(double)frequency[face-2]/times;
//     degree[face-2] = (int)(percentage[face-2]*360.0);
//     System.out.println("\t" + degree[face-2]);
   }
 }

// Implement java.lang.Runnable.run:
 public void run()
 {
   int t=0;
   for (int roll=1; roll<=total; roll++) {
     rolldice(); // call rolldice()
     // the chart repaint each 100 times of rolling the 2 dices, ++t can be 
     // adjusted from 1 to 8000
     if (++t == 100) {
       repaint();
       try {
         Thread.sleep(100);
       }catch(InterruptedException e) { // Do nothing }
       t = 0;
     }
   }
   repaint();
 }


// Override java.awt.Component.update
 public void update(Graphics g)
 {
  paint(g);
 }

// Override java.awt.Component.paint
 public void paint(Graphics g)
 {
  int _degree = 0;
  // fill background
  offscreenG.setColor(getBackground());
  offscreenG.fillRect(0,0,this.size().width-1, this.size().height-1);
//  offscreenG.setColor(getForeground());
//  offscreenG.drawArc(0,0,201,201, 0, 360);

  // draw all the 11 sectors in the pie chart, fill them with colors
  offscreenG.setColor(Color.red);
  offscreenG.drawArc(0,0,200,200,_degree,degree[0]);
  offscreenG.fillArc(0,0,200,200,_degree,degree[0]);
  _degree += degree[0];
//  System.out.println(_degree + " " +degree[0]); 

  offscreenG.setColor(Color.yellow);
  offscreenG.drawArc(0,0,200,200,_degree,degree[1]);
  offscreenG.fillArc(0,0,200,200,_degree,degree[1]);
  _degree += degree[1];
//  System.out.println(_degree + " "+ degree[1]); 

  offscreenG.setColor(Color.blue);
  offscreenG.drawArc(0,0,200,200,_degree,degree[2]);
  offscreenG.fillArc(0,0,200,200,_degree,degree[2]);
  _degree += degree[2];
//  System.out.println(_degree + " " +degree[2]); 

  offscreenG.setColor(Color.green);
  offscreenG.drawArc(0,0,200,200,_degree,degree[3]);
  offscreenG.fillArc(0,0,200,200,_degree,degree[3]);                         
  _degree += degree[3];
//  System.out.println(_degree + " " +degree[3]); 

  offscreenG.setColor(Color.yellow);
  offscreenG.drawArc(0,0,200,200,_degree,degree[4]);
  offscreenG.fillArc(0,0,200,200,_degree,degree[4]);
  _degree += degree[4];
//  System.out.println(_degree + " " +degree[4]); 

  offscreenG.setColor(Color.blue);
  offscreenG.drawArc(0,0,200,200,_degree,degree[5]);
  offscreenG.fillArc(0,0,200,200,_degree,degree[5]);            
  _degree += degree[5];
//  System.out.println(_degree + " " +degree[5]); 

  offscreenG.setColor(Color.yellow);
  offscreenG.drawArc(0,0,200,200,_degree,degree[6]);
  offscreenG.fillArc(0,0,200,200,_degree,degree[6]);
  _degree += degree[6];
//  System.out.println(_degree + " " +degree[6]); 

  offscreenG.setColor(Color.green);
  offscreenG.drawArc(0,0,200,200,_degree,degree[7]);
  offscreenG.fillArc(0,0,200,200,_degree,degree[7]);
  _degree += degree[7];
//  System.out.println(_degree + " " +degree[7]); 

  offscreenG.setColor(Color.blue);
  offscreenG.drawArc(0,0,200,200,_degree,degree[8]);    
  offscreenG.fillArc(0,0,200,200,_degree,degree[8]);
  _degree += degree[8];
//  System.out.println(_degree + " " +degree[8]); 

  offscreenG.setColor(Color.yellow);
  offscreenG.drawArc(0,0,200,200,_degree,degree[9]);
  offscreenG.fillArc(0,0,200,200,_degree,degree[9]);
  _degree += degree[9];
//  System.out.println(_degree + " " +degree[9]); 

  offscreenG.setColor(Color.cyan);
//  offscreenG.drawArc(0,0,200,200,_degree,degree[10]);
//  offscreenG.fillArc(0,0,200,200,_degree,degree[10]);
  offscreenG.drawArc(0,0,200,200,_degree,360-_degree);
  offscreenG.fillArc(0,0,200,200,_degree,360-_degree);
//  System.out.println(_degree + " " + (360-_degree)); 

// Draw the buffer in the applet window:
  g.drawImage(offscreenImg,0,0,this);
 }
}

                                                                     

